AchievementFrozen = class(Turbine.UI.Control)
function AchievementFrozen:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Swift Strike"] = true,
        ["Wild Attack"] = true,
        ["Fear Nothing!"] = true,
        ["Devastating Strike"] = true,
        ["Rend"] = true,
        ["Controlled Burn"] = true,
        ["Champion's Duel"] = true,
    }

    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    self.command = Turbine.ShellCommand()
    function self.command:Execute()
        HardcoreHandler:GetAchievementHint("Frozen")
    end

    Turbine.Shell.AddCommand("hardcorefrozen", self.command)


    self.handler = handler

    self:SetCallbacks()
end

function AchievementFrozen:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then

            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Frozen", "Usage of a non frost skill", 0x410E81CB)
            end))
        end
    end
end

function AchievementFrozen:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
end

function AchievementFrozen:Refresh()
    self:Unload()
    self:SetCallbacks()
end

function AchievementFrozen:GetHint()
    ChatOutput("<rgb=#005500>Only use frost skills.")
    ChatOutput("<rgb=#FF0000>Skills that are not allowed:")
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end